/** \file menu.c ***********************************************************
 * 
 *             Project: Sonoma (MAXREFDES14#)
 *            Filename: menu.c
 *         Description: This module contains all the functions used to
 *                      generate the menus and menu options used to run the
 *                      MAXREFDES14# example firmware.
 * 
 *    Revision History:
 *\n                    05-31-13    Rev 01.00    GL    Initial Release
 *
 *  --------------------------------------------------------------------
 *
 *  This code follows the following naming conventions:
 *
 *\n    char                    chPmodValue
 *\n    char (array)            sPmodString[16]
 *\n    float                   fPmodValue
 *\n    int                     nPmodValue
 *\n    int (array)             anPmodValue[16]
 *\n    u16                     uPmodValue
 *\n    u16 (array)             auPmodValue[16]
 *\n    u8                      uchPmodValue
 *\n    u8 (array)              auchPmodBuffer[16]
 *\n    unsigned int            unPmodValue
 *\n    int *                   punPmodValue
 *
 *  ------------------------------------------------------------------------- */
/*
 * Copyright (C) 2012 Maxim Integrated Products, Inc., All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL MAXIM INTEGRATED PRODUCTS BE LIABLE FOR ANY CLAIM, DAMAGES
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name of Maxim Integrated Products
 * shall not be used except as stated in the Maxim Integrated Products
 * Branding Policy.
 *
 * The mere transfer of this software does not imply any licenses
 * of trade secrets, proprietary technology, copyrights, patents,
 * trademarks, maskwork rights, or any other form of intellectual
 * property whatsoever. Maxim Integrated Products retains all ownership rights.
 *
 ***************************************************************************/

#include <stdio.h>
#include "platform.h"
#include "xparameters.h"
#include "utilities.h"
#include "string.h"
#include "MAXREFDES14.h"
#include "maximDeviceSpecificUtilities.h"
#include "menu.h"

void menu_cls()
/**
* \brief       Function to clear the screen via Hyperterminal
*
* \param       None
*
* \retval      None
*/
{
	// The following code will cause a clear screen event on Hyperterminal and many other terminal emulators
	printf("\033[2J");
}


void menu_print_maxim_banner()
/**
* \brief       Print standard Maxim banner at top of Hyperterminal screen
*
* \param       None
*
* \retval      None
*/
{
	printf( "\r\n");
	printf( "///////////////////////////////////////////////////////////////////\r\n");
	printf( "//                        _____    _____                         //\r\n");
	printf( "//                       /  __ \\  / __  \\                        //\r\n");
	printf( "//                       | |  \\/ / /  | |                        //\r\n");
	printf( "//                       | |    / /   | |                        //\r\n");
	printf( "//                       | |   /  \\   | |                        //\r\n");
	printf( "//                       | |  / /\\ \\  | |                        //\r\n");
	printf( "//                       |_| /_/  \\_\\ |_|                        //\r\n");
	printf( "//                                                               //\r\n");
	printf( "///////////////////////////////////////////////////////////////////\r\n");
	printf("\r\n");
}


void menu_print_maxim_banner_big()
/**
* \brief       Print large Maxim banner at top of Hyperterminal screen
*
* \param       None
*
* \retval      None
*/
{
	printf( "\r\n");
	printf( "///////////////////////////////////////////////////////////////////\r\n");
	printf( "//                          ###   ###                            //\r\n");
	printf( "//                      ##             ##                        //\r\n");
	printf( "//                                                               //\r\n");
	printf( "//                   ##   _____    _____   ##                    //\r\n");
	printf( "//                       /  __ \\  / __  \\                        //\r\n");
	printf( "//                  ##   | |  \\/ / /  | |   ##                   //\r\n");
	printf( "//                       | |    / /   | |                        //\r\n");
	printf( "//                       | |   /  \\   | |                        //\r\n");
	printf( "//                  ##   | |  / /\\ \\  | |   ##                   //\r\n");
	printf( "//                       |_| /_/  \\_\\ |_|                        //\r\n");
	printf( "//                   ##                    ##                    //\r\n");
	printf( "//                                                               //\r\n");
	printf( "//                      ##             ##                        //\r\n");
	printf( "//                          ###   ###                            //\r\n");
	printf( "//                                                               //\r\n");
	printf( "//                M A X I M   I N T E G R A T E D                //\r\n");
	printf( "//                                                               //\r\n");
	printf( "///////////////////////////////////////////////////////////////////\r\n");

	printf("\r\n\r\n");
}

void menu_print_prompt()
/**
* \brief       Print a standard prompt for keyboard input "  > "
*
* \param       None
*
* \retval      None
*/
{
	printf("\r\n>> ");
	fflush(stdout);
}


void menu_print_line()
/**
* \brief       Print one line of dashes across the screen via Hyperterminal
*
* \param       None
*
* \retval      None
*/
{
	printf("----------------------------------------------------\r\n\r\n");
}

u8 menu_retrieve_keypress(u32 nUartAddress)
/**
* \brief       Get a single keypress via Hyperterminal.
* \par         Details
*              Returns ascii character corresponding to keypress with some preprocessing.
* \n           Lower case "a"-"z" converted to uppercase "A"-"Z"
*
* \param[in]   nUartAddress        - address of the UART peripheral in MicroBlaze memory map
*
* \retval      Character, partially decoded.
*/
{
	u8 uchInput;

	uchInput = getUartByte(nUartAddress);

	if(uchInput>=97 && uchInput<=122)
		uchInput -=32;  // convert lowercase to uppercase

	return(uchInput);
}

void menu_print_main_menu()
/**
* \brief       Print the main menu listing choice of module to test
* \par         Details.
*
* \retval      None
*/
{
	menu_print_maxim_banner();

	printf("Press a number to select read or write operation:\r\n");

	printf("{0} Register Read\n"\
		"{1} Register Write\n");

	menu_print_prompt();
}


